﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

using ll = long long;
const ll inf = ll(1e18);

int main()
{
    ll n, m, k; cin >> n >> m >> k;
    vector<vector<ll>> G(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b; cin >> a >> b;
        G[a - 1].push_back(b - 1);
        G[b - 1].push_back(a - 1);
    }
    vector<ll> V(n, 0);
    for (ll i = 0; i < k; ++i) {
        ll p, h; cin >> p >> h;
        p--;
        vector<ll> dist(n, inf);
        dist[p] = 0;
        queue<ll> q;
        q.push(p);
        while (!q.empty()) {
            ll v = q.front();
            q.pop();
            if (dist[v] <= h) V[v] = 1;
            for (ll u : G[v]) {
                if (dist[u] > dist[v] + 1) {
                    dist[u] = dist[v] + 1;
                    q.push(u);
                }
            }
        }
    }
    cout << count(V.begin(), V.end(), 1) << '\n';
    for (ll i = 0; i < n; ++i) {
        if (V[i]) cout << i + 1 << ' ';
    }
}
