﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

using ll = long long;
const ll inf = ll(1e18);

int main()
{
    ll n, m, k; cin >> n >> m >> k;
    vector<vector<ll>> G(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b; cin >> a >> b;
        G[a - 1].push_back(b - 1);
        G[b - 1].push_back(a - 1);
    }

    if (n > 5000) {
        vector<ll> V(n, -1);
        for (ll i = 0; i < k; ++i) {
            ll p, h; cin >> p >> h;
            V[p - 1] = h;
        }
        ll s;
        for (ll i = 0; i < n; ++i) {
            if (G[i].size() == 1) s = i;
        }
        vector<ll> B(n);
        ll s1 = s;
        for (ll i = 0; i < n; ++i) {
            B[i] = s;
            if (G[s].size() == 1 && G[s][0] != s1) {
                s1 = s;
                s = G[s][0];
            }
            else if (G[s].size() > 1) {
                ll u1 = G[s][0], u2 = G[s][1];
                if (u1 == s1) {
                    s1 = s;
                    s = u2;
                }
                else {
                    s1 = s;
                    s = u1;
                }
            }
        }
        vector<ll> ans(n, 0);
        ll tec = 0;
        for (ll i = 0; i < n; ++i) {
            if (V[i] != -1) {
                ans[i] = 1;
                tec = max(tec, i + V[i]);
                continue;
            }
            if (i <= tec) {
                ans[i] = 1;
            }
        }
        tec = n - 1;
        for (ll i = n - 1; i > -1; --i) {
            if (V[i] != -1) {
                tec = min(tec, i - V[i]);
                continue;
            }
            if (i >= tec) {
                ans[i] = 1;
            }
        }
        cout << count(ans.begin(), ans.end(), 1) << '\n';
        for (ll i = 0; i < n; ++i) {
            if (ans[i]) cout << i + 1 << ' ';
        }
        return 0;
    }

    vector<ll> V(n, 0);
    for (ll i = 0; i < k; ++i) {
        ll p, h; cin >> p >> h;
        p--;
        vector<ll> dist(n, inf);
        dist[p] = 0;
        queue<ll> q;
        q.push(p);
        while (!q.empty()) {
            ll v = q.front();
            q.pop();
            if (dist[v] <= h) V[v] = 1;
            for (ll u : G[v]) {
                if (dist[u] > dist[v] + 1) {
                    dist[u] = dist[v] + 1;
                    q.push(u);
                }
            }
        }
    }
    cout << count(V.begin(), V.end(), 1) << '\n';
    for (ll i = 0; i < n; ++i) {
        if (V[i]) cout << i + 1 << ' ';
    }
}
