﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

using ll = long long;
const ll inf = ll(1e18);

vector<vector<ll>> G;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m, k; cin >> n >> m >> k;
    G.resize(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b; cin >> a >> b;
        G[a - 1].push_back(b - 1);
        G[b - 1].push_back(a - 1);
    }
    vector<ll> V(n, -1);
    set<ll> P;
    for (ll i = 0; i < k; ++i) {
        ll p, h; cin >> p >> h;
        V[p - 1] = h;
        P.insert(p - 1);
    }

    vector<ll> dist(n, -1);
    while (P.begin() != P.end()) {
        ll s = *P.rbegin();

        dist[s] = V[s];
        queue<ll> q;
        q.push(s);
        while (!q.empty()) {
            ll v = q.front();
            if (V[v] != -1) P.erase(v);
            q.pop();
            for (ll u : G[v]) {
                if (V[u] != -1 && dist[u] < V[u]) {
                    dist[u] = max(V[u], dist[v] - 1);
                    q.push(u);
                    continue;
                }
                if (dist[u] < dist[v] - 1) {
                    dist[u] = dist[v] - 1;
                    q.push(u);
                    continue;
                }
            }
        }
    }

    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        if (dist[i] >= 0) ans++;
    }
    cout << ans << '\n';
    for (ll i = 0; i < n; ++i) {
        if (dist[i] >= 0) cout << i + 1 << ' ';
    }
}