﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

using ll = long long;
const ll inf = ll(1e18);

vector<vector<ll>> G;

int main()
{
    ll n, m, k; cin >> n >> m >> k;
    G.resize(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b; cin >> a >> b;
        G[a - 1].push_back(b - 1);
        G[b - 1].push_back(a - 1);
    }
    vector<ll> V(n, -1);
    for (ll i = 0; i < k; ++i) {
        ll p, h; cin >> p >> h;
        V[p - 1] = h;
    }

    vector<ll> dist(n, -1);
    while (true) {
        ll s = -1;
        for (ll i = 0; i < n; ++i) {
            if (V[i] != -1 && dist[i] < V[i]) {
                s = i; break;
            }
        }
        if (s == -1) break;

        dist[s] = V[s];
        queue<ll> q;
        q.push(s);
        while (!q.empty()) {
            ll v = q.front();
            q.pop();
            for (ll u : G[v]) {
                if (V[u] != -1 && dist[u] == -1) {
                    dist[u] = max(V[u], dist[v] - 1);
                    q.push(u);
                    continue;
                }
                if (dist[u] < dist[v] - 1) {
                    dist[u] = max(dist[u], dist[v] - 1);
                    q.push(u);
                    continue;
                }
            }
        }
    }

    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        if (dist[i] >= 0) ans++;
    }
    cout << ans << '\n';
    for (ll i = 0; i < n; ++i) {
        if (dist[i] >= 0) cout << i + 1 << ' ';
    }
}
